#produce an image mos1S001-obj-im.fits in 0.3-8 keV in sky coordinate
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0) &&((CCDNR == 1)||(CCDNR == 2)||(CCDNR == 4)||(CCDNR == 5)||(CCDNR == 7))&&region(mos1S001-bkg_region-sky.fits)&&(PI in [300:8000])' filtertype=expression imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-obj-im.fits squarepixels=yes ignorelegallimits=yes withxranges=yes withyranges=yes xcolumn='X' ximagesize=900 ximagemax=48400 ximagemin=3401 ycolumn='Y' yimagesize=900 yimagemax=48400 yimagemin=3401 updateexposure=yes filterexposure=yes
   

#produce an image mos1S001-obj-im-sp-det.fits in the whole energy range
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-obj-im-sp-det.fits squarepixels=yes ignorelegallimits=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes
   
#produce an image mos1S001-obj-im-det-400-2300.fits in 0.4-2.3 keV in detector coordinate
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes filtertype=expression expression='(PATTERN<=12)&&(FLAG == 0) &&((CCDNR == 1)||(CCDNR == 2)||(CCDNR == 4)||(CCDNR == 5)||(CCDNR == 7))&&region(mos1S001-bkg_region-det.fits)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-obj-im-det-400-2300.fits squarepixels=yes ignorelegallimits=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes

#produce atthk.fits for expousre maps   
atthkgen atthkset=atthk.fits timestep=1 
   
#produce an exposure map mos1S001-exp-im.fits in 0.3-8 keV using the image produced in the previous step
eexpmap attitudeset=atthk.fits eventset=mos1S001-clean.fits:EVENTS expimageset=mos1S001-exp-im.fits imageset=mos1S001-obj-im.fits pimax=8000 pimin=300 withdetcoords=no
   
#produce a mask mos1S001-mask-im.fits indicating the ccd gaps and bad pixels. 
emask detmaskset=mos1S001-mask-im.fits expimageset=mos1S001-exp-im.fits threshold1=0.01 threshold2=0.5
   

#produce a spectrum mos1S001-obj.pi 
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-obj.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
   
#calculate the area of the spectrum mos1S001-obj.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes
   
#produce a temporary image detmap.ds in detector coordinate in the whole energy range for the next step
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes filtertype=expression expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' imagebinning='imageSize' imagedatatype='Int32' imageset=detmap.ds squarepixels=yes ignorelegallimits=no withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=120 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=120 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes
   
#produce the rmf mos1S001.rmf file which contains information of channel to energy conversion
rmfgen format=var rmfset=mos1S001.rmf spectrumset=mos1S001-obj.pi threshold=1.0e-6 detmaptype=dataset detmaparray=detmap.ds

#produce a temporary image detmap.ds again in detector coordinate in the whole energy range for the next step
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes filtertype=expression expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' imagebinning='imageSize' imagedatatype='Int32' imageset=detmap.ds squarepixels=yes ignorelegallimits=no withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=120 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=120 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes
   
#produce the effective area file mos1S001.arf
arfgen arfset=mos1S001.arf spectrumset=mos1S001-obj.pi withrmfset=yes rmfset=mos1S001.rmf extendedsource=yes modelee=no withbadpixcorr=no detmaptype=dataset detmaparray=detmap.ds  badpixlocation=mos1S001-clean.fits modelootcorr=no
   
#produce an image mos1S001-obj-im-400-2300.fits in 0.4-2.3 keV in sky coordinate
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0) &&((CCDNR == 1)||(CCDNR == 2)||(CCDNR == 4)||(CCDNR == 5)||(CCDNR == 7))&&region(mos1S001-bkg_region-sky.fits)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))'  filtertype=expression imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-obj-im-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='X' ximagesize=900 ximagemax=48400 ximagemin=3401 ycolumn='Y' yimagesize=900 yimagemax=48400 yimagemin=3401 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#produce an exposure map mos1S001-exp-im-400-2300.fits in 0.4-2.3 keV
eexpmap attitudeset=atthk.fits eventset=mos1S001-clean.fits:EVENTS expimageset=mos1S001-exp-im-400-2300.fits imageset=mos1S001-obj-im-400-2300.fits pimax=2300 pimin=400 withdetcoords=no
   
#produce a mask mos1S001-mask-im-400-2300.fits indicating the ccd gaps and bad pixels using the exposure map produced in the previous step
emask detmaskset=mos1S001-mask-im-400-2300.fits expimageset=mos1S001-exp-im-400-2300.fits threshold1=0.1 threshold2=0.5
   
#produce a spectrum of ccd1 mos1S001-1ff.pi from the filter wheel closed files 
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&((DETX,DETY) in BOX(20,-60,6610,6570,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' withspectrumset=yes spectrumset=mos1S001-1ff.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
   
#calculate the area of the spectrum mos1S001-1ff.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-1ff.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes
   
#produce an image mos1S001-obj-im-400-2300-ccd1.fits of ccd1 only in 0.4-2.3 keV in detector coordinate
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(20,-60,6610,6570,0))&&(PATTERN<=12)&&(FLAG == 0) &&((CCDNR == 1)||(CCDNR == 2)||(CCDNR == 4)||(CCDNR == 5)||(CCDNR == 7))&&region(mos1S001-bkg_region-det.fits)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))'  filtertype=expression imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-obj-im-400-2300-ccd1.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#produce an exposure map mos1S001-exp-im-400-2300-ccd1.fits using the above image in 0.4-2.3 keV
eexpmap attitudeset=atthk.fits eventset=mos1S001-clean.fits:EVENTS expimageset=mos1S001-exp-im-400-2300-ccd1.fits imageset=mos1S001-obj-im-400-2300-ccd1.fits pimax=2300 pimin=400 withdetcoords=yes

#produce a mask mos1S001-mask-im-400-2300-ccd1.fits indicating the ccd gaps and bad pixels using the image and expousre map produced in the previous two steps
emask detmaskset=mos1S001-mask-im-400-2300-ccd1.fits expimageset=mos1S001-exp-im-400-2300-ccd1.fits threshold1=0.01 threshold2=0.5
   
#produce an image mos1S001-im1-400-2300.fits of ccd1 only of the filter wheel closed data in 0.4-2.3 keV in detector coordinate
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN <= 12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&((DETX,DETY) in BOX(20,-60,6610,6570,0))&&(PI in [400:2300])' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-im1-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500 yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#multiply mos1S001-im1-400-2300.fits with mos1S001-mask-im-400-2300-ccd1.fits to produce a new file mos1S001-im1-400-2300-mask.fits
farith mos1S001-im1-400-2300.fits 'mos1S001-mask-im-400-2300-ccd1.fits[MASK]' mos1S001-im1-400-2300-mask.fits MUL copyprime=yes 
 
#rename mos1S001-im1-400-2300-mask.fits to mos1S001-im1-400-2300.fits   
mv mos1S001-im1-400-2300-mask.fits mos1S001-im1-400-2300.fits 

#produce a spectrum mos1S001-1obj.pi of ccd1 only
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(20,-60,6610,6570,0))&&(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-1obj.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999

#calculate the area of the spectrum mos1S001-1obj.pi, which is "BACKSCAL" in the header   
backscale spectrumset=mos1S001-1obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes
   
#produce a spectrum mos1S001-2oc.pi of the corner of ccd2 only
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(6550,-13572,6590,6599,0))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-2oc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999

#calculate the area of the spectrum mos1S001-2oc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-2oc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no
   
#produce a spectrum mos1S001-2obj.pi of ccd2 only
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-2obj.pi energycolumn=PI  spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999

#calculate the area of the spectrum mos1S001-2obj.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-2obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce temporary event list temp_events.fits with events in 0.3-10keV from the corner of ccd2 only. The BOX indicates the coordinates of ccd2. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&(PI in [300:10000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 0.5-0.8keV from the corner of ccd2 only. The BOX indicates the coordinates of ccd2. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&(PI in [500:800])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 2.5-5.0keV from the corner of ccd2 only. The BOX indicates the coordinates of ccd2. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&(PI in [2500:5000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce a spectrum of the corner of ccd2 only mos1S001-2fc.pi from the filter wheel closed files
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&!(((DETX,DETY) in CIRCLE(100,-200,17700))||((DETX,DETY) in CIRCLE(834,135,17100))||((DETX,DETY) in CIRCLE(770,-803,17100))||((DETX,DETY) in BOX(-20,-17000,6500,500,0))||((DETX,DETY) in BOX(5880,-20500,7500,1500,10))||((DETX,DETY) in BOX(-5920,-20500,7500,1500,350))||((DETX,DETY) in BOX(-20,-20000,5500,500,0)))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-2fc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-2fc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-2fc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no 

#produce a spectrum of ccd2 only mos1S001-2ff.pi from the filter wheel closed files 
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' withspectrumset=yes keepfilteroutput=no updateexposure=yes filterexposure=yes spectrumset=mos1S001-2ff.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 

#calculate the area of the spectrum mos1S001-2ff.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-2ff.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce an image mos1S001-im2-400-2300.fits of ccd2 only of the filter wheel closed data in 0.4-2.3 keV in detector coordinate
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(6550,-13572,6590,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(FLAG == 0)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-im2-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500  yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#produce a spectrum mos1S001-4oc.pi of the corner of ccd4 only
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(6700,13070,6530,6560,0))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-4oc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
   
#calculate the area of the spectrum mos1S001-4oc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-4oc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no

#produce a spectrum mos1S001-4obj.pi of ccd4 only
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-4obj.pi energycolumn=PI  spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
  
#calculate the area of the spectrum mos1S001-4obj.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-4obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce temporary event list temp_events.fits with events in 0.3-10keV from the corner of ccd4 only. The BOX indicates the coordinates of ccd4. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&(PI in [300:10000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
  
#produce temporary event list temp_events.fits with events in 0.5-0.8keV from the corner. The BOX indicates the coordinates of ccd4. Extract an image yourself to check. 
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&(PI in [500:800])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 2.5-5.0keV from the corner. The BOX indicates the coordinates of ccd4. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&(PI in [2500:5000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce a spectrum of the corner of ccd4 only mos1S001-4fc.pi from the filter wheel closed files
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&!(((DETX,DETY) in CIRCLE(100,-200,17700))||((DETX,DETY) in CIRCLE(834,135,17100))||((DETX,DETY) in CIRCLE(770,-803,17100))||((DETX,DETY) in BOX(-20,-17000,6500,500,0))||((DETX,DETY) in BOX(5880,-20500,7500,1500,10))||((DETX,DETY) in BOX(-5920,-20500,7500,1500,350))||((DETX,DETY) in BOX(-20,-20000,5500,500,0)))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-4fc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-4fc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-4fc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no 
   
#produce a spectrum of ccd4 only mos1S001-4ff.pi from the filter wheel closed files
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' withspectrumset=yes keepfilteroutput=no updateexposure=yes filterexposure=yes spectrumset=mos1S001-4ff.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
 
#calculate the area of the spectrum mos1S001-4ff.pi, which is "BACKSCAL" in the header  
backscale spectrumset=mos1S001-4ff.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce an image mos1S001-im4-400-2300.fits of ccd4 only of the filter wheel closed data in 0.4-2.3 keV in detector coordinate
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(6700,13070,6530,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(FLAG == 0)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-im4-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500  yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#produce a spectrum mos1S001-5oc.pi of the corner of ccd5 only
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(-6410,13130,6570,6560,0))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-5oc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999

#calculate the area of the spectrum mos1S001-5oc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-5oc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no
   
#produce a spectrum of ccd5 only mos1S001-5obj.pi
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-5obj.pi energycolumn=PI  spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
 
#calculate the area of the spectrum mos1S001-5obj.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-5obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce temporary event list temp_events.fits in 0.3-10.0keV from the corner of ccd5 only. The BOX indicates the coordinates of ccd5. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&(PI in [300:10000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 0.5-0.8keV from the corner of ccd5 only. The BOX indicates the coordinates of ccd5. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&(PI in [500:800])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 2.5-5.0keV from the corner of ccd5 only. The BOX indicates the coordinates of ccd5. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&(PI in [2500:5000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&!(((DETX,DETY) in CIRCLE(100,-200,17700))||((DETX,DETY) in CIRCLE(834,135,17100))||((DETX,DETY) in CIRCLE(770,-803,17100))||((DETX,DETY) in BOX(-20,-17000,6500,500,0))||((DETX,DETY) in BOX(5880,-20500,7500,1500,10))||((DETX,DETY) in BOX(-5920,-20500,7500,1500,350))||((DETX,DETY) in BOX(-20,-20000,5500,500,0)))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-5fc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-5fc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-5fc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no 
   
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' withspectrumset=yes keepfilteroutput=no updateexposure=yes filterexposure=yes spectrumset=mos1S001-5ff.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-5ff.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-5ff.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce an image mos1S001-im5-400-2300.fits of ccd5 only of the filter wheel closed data in 0.4-2.3 keV in detector coordinate
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(-6410,13130,6570,6560,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(FLAG == 0)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-im5-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500  yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#produce a spectrum mos1S001-7oc.pi of the corner of ccd7 only
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-7oc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
  
#calculate the area of the spectrum mos1S001-7oc.pi, which is "BACKSCAL" in the header 
backscale spectrumset=mos1S001-7oc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no
   
#produce a spectrum of ccd7 only mos1S001-7obj.pi
evselect table=mos1S001-clean.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' filtertype=expression keepfilteroutput=no updateexposure=yes filterexposure=yes withspectrumset=yes spectrumset=mos1S001-7obj.pi energycolumn=PI  spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999
   
#calculate the area of the spectrum mos1S001-7obj.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-7obj.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce temporary event list temp_events.fits with events in 0.3-10.0keV from the corner of ccd7 only. The BOX indicates the coordinates of ccd7. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&(PI in [300:10000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 0.5-0.8keV from the corner of ccd7 only. The BOX indicates the coordinates of ccd7. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&(PI in [500:800])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce temporary event list temp_events.fits with events in 2.5-5.0keV from the corner of ccd7 only. The BOX indicates the coordinates of ccd7. Extract an image yourself to check.
evselect table=mos1S001-corn.fits:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&(PI in [2500:5000])' filtertype=expression filteredset=temp_events.fits keepfilteroutput=yes updateexposure=yes filterexposure=yes 
   
#produce a spectrum of the corner of ccd7 only mos1S001-7fc.pi from the filter wheel closed files
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(PATTERN<=12)&&((FLAG & 0x766a0f63)==0)&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&!(((DETX,DETY) in CIRCLE(100,-200,17700))||((DETX,DETY) in CIRCLE(834,135,17100))||((DETX,DETY) in CIRCLE(770,-803,17100))||((DETX,DETY) in BOX(-20,-17000,6500,500,0))||((DETX,DETY) in BOX(5880,-20500,7500,1500,10))||((DETX,DETY) in BOX(-5920,-20500,7500,1500,350))||((DETX,DETY) in BOX(-20,-20000,5500,500,0)))' filtertype=expression keepfilteroutput=no withspectrumset=yes spectrumset=mos1S001-7fc.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-7fc.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-7fc.pi useodfatt=no badpixlocation=mos1S001-clean.fits withbadpixcorr=yes ignoreoutoffov=no 
   
#produce a spectrum of ccd7 only mos1S001-7ff.pi from the filter wheel closed files
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='(FLAG == 0)&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))&&((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)' withspectrumset=yes keepfilteroutput=no updateexposure=yes filterexposure=yes spectrumset=mos1S001-7ff.pi energycolumn=PI spectralbinsize=5 withspecranges=yes specchannelmin=0 specchannelmax=11999 
   
#calculate the area of the spectrum mos1S001-7ff.pi, which is "BACKSCAL" in the header
backscale spectrumset=mos1S001-7ff.pi badpixlocation=mos1S001-clean.fits withbadpixcorr=yes 
   
#produce an image mos1S001-im7-400-2300.fits of ccd7 only of the filter wheel closed data in 0.4-2.3 keV in detector coordinate
evselect table=mos1-fwc.fits.gz:EVENTS withfilteredset=yes expression='((DETX,DETY) in BOX(-6540,-13438,6570,6599,0))&&!((DETX,DETY) in BOX(13280,-306,6610,6599,0))&&!((DETX,DETY) in BOX(-13169,-105,6599,6599,0))&&region(mos1S001-bkg_region-det.fits)&&(FLAG == 0)&&(PI in [400:2300])&&(((DETX,DETY) IN box(-2683.5,-15917,2780.5,1340,0))||((DETX,DETY) IN box(2743.5,-16051,2579.5,1340,0))||((DETX,DETY) IN circle(97,-172,17152)))' imagebinning='imageSize' imagedatatype='Int32' imageset=mos1S001-im7-400-2300.fits squarepixels=yes withxranges=yes withyranges=yes xcolumn='DETX' ximagesize=780 ximagemax=19500 ximagemin=-19499 ycolumn='DETY' yimagesize=780 yimagemax=19500  yimagemin=-19499 updateexposure=yes filterexposure=yes ignorelegallimits=yes 
   
#coordinate conversion 
esky2det datastyle=user ra=16.685125 dec=1.07061111111111 outunit=det withheader=no calinfostyle=set calinfoset=pnS003-obj-im-400-2300.fits verbosity=0

#produce mos1S001-back-im-sky-400-2300.fits from mos1S001-back-im-det-400-2300.fits
rot_det_sky mode=1 prefix=S003 elow=400 ehigh=2300 detx=-1100.411004 dety=1477.414774 skyx=450.91 skyy=450.91 maskfile=1 clobber=1
